class Example
{
  public int a;
  public double b;
  public String s;  // a String inside of the object
  public Example(int a, double b, String s)
  { this.a = a; this.b = b; this.s = s; }
}

public class Working_with_objects_and_strings
{
   public static Example s1 = new Example(8, 7.6, "54321");  // a "global" variable

   public static boolean f(Example s1, Example s2)
   {
      if (s1.a != s2.a) {
         s2.a = s1.a;  // a side effect
         return false;
      }
      if (s1.b != s2.b) {
         s2.b = s1.b;  // a side effect
         return false;
      }
      if (! s1.s.equals(s2.s) ) {
         s2.s = s1.s;  // a side effect
         return false;
      }
      return true;
   }

   public static void main(String[] args)
   {
      Example s2 = new Example(1, 2.3, "cat");
      Example s3 = new Example(5, 6.7, "dogs");
      boolean r1 = f(s2, s3);
      boolean r2 = f(new Example(4, 3.2, "x"), s1);
              r2 = f(new Example(4, 3.2, "x"), s1);
              r2 = f(new Example(4, 3.2, "x"), s1);
              r2 = f(new Example(4, 3.2, "x"), s1);
      System.out.printf("%b, %b\n", r1, r2);
   }
}
