struct example {
  int a;
  double b;
  char c[4];  // a string inside of the struct
};

int f(struct example *s1, struct example s2)
{
  if (s1->a != s2.a)
     return 0;
  if (s1->b != s2.b)
     return 0;
  if (! g(s1->c, s2.c))
     return 0;
  return 1;
}

int g(char s1[5], char s2[5])
{
  if (strlen(s1) != strlen(s2))
     return 0;

  int result = 1;
  for (int i = 0; i < strlen(s1); i++)
  {
    if (s1[i] != s2[i])
    {
       result = 0;
       break;
    }
  }
  return result;
}

int main() {
  struct example s1 = {1, 2.3, "cat"};
  struct example s2 = {1, 2.3, "dog"};
  int r1 = f(&s1, s2);

  struct example *s3 = malloc(sizeof(struct example));
  struct example *s4 = malloc(sizeof(struct example));
  s3->a = 4;
  s3->b = 5.6;
  //s3->c = "cat";
  s3->c[0] = 'c';
  s3->c[1] = 'a';
  s3->c[2] = 't';
  s3->c[3] = '\0';
  s4->a = 4;
  s4->b = 5.6;
  s4->c[0] = 'd';
  s4->c[1] = 'o';
  s4->c[2] = 'g';
  s4->c[3] = '\0';
  int r2 = f(s3, *s4);
  return 0;
}
