#include <stdio.h>
#include <stdlib.h>

struct example {
  int a;
  double b;
  char c;
};

struct example s1 = {8, 7.6, '5'};  // a global variable

int f(struct example s1, struct example s2) {
  if (s1.a != s2.a) {
     return 0;
  }
  if (s1.b != s2.b) {
     return 0;
  }
  if (s1.c != s2.c) {
     return 0;
  }
  return 1;
}

int f2(struct example *s1, struct example *s2) {
  if (s1->a != s2->a) {
     s2->a = s1->a;  // a side effect
     return 0;
  }
  if (s1->b != s2->b) {
     s2->b = s1->b;  // a side effect
     return 0;
  }
  if (s1->c != s2->c) {
     s2->c = s1->c;  // a side effect
     return 0;
  }
  struct example *lost = (int*)malloc(sizeof(struct example));
  return 1;
}

int main() {
  struct example s2 = {1, 2.3, '4'};
  struct example s3 = {5, 6.7, '8'};
  int r1 = f(s2, s3);
  int r2 = f((struct example){4, 3.2, '1'}, s3);
  struct example *s4 = (int*)malloc(sizeof(struct example));
  (*s4).a = 12;
  (*s4).b = 34.5;
  s4->c = '6';
  int r3 = f(s1, *s4);   // s4 is copied from heap to stack
  int r4 = f2(&s1, s4);  // f2 can hve side effects
      r4 = f2(&s1, s4);  // f2 can hve side effects
      r4 = f2(&s1, s4);  // f2 can hve side effects
      r4 = f2(&s1, s4);
  printf("%d, %d, %d, %d\n", r1, r2, r3, r4);
  free(s4);
  return 0;
}
