#include <stdio.h>
#include <stdlib.h>

char s1[] = "pear";  // a global variable

//int f(char  s1[], char  s2[]){
//int f(char *s1,   char *s2) {
int f(char s1[5], char s2[5]) {  // the 5's are ignored
  if (strlen(s1) != strlen(s2))
     return 0;

  int result = 1;
  for (int i = 0; i < strlen(s1); i++)
  {
    if (s1[i] != s2[i])
    {
       result = 0;
       s2[i] = s1[i];  // a side effect
       break;
    }
  }
  return result;
}

int main() {
  char s2[]  = "cat";   // local variable
  char s3[5] = "cog";   // local variable
  int r1 = f(s2, s3);
  int r2 = f("apple", s1);
  char *s4 = (char*)malloc(10 * sizeof(char));
  for (int i = 0; i < 10; i++)
  {
     s4[i] = 'a' + i;
  }
  s4[4] = '\0'; // make s4 into a string (of length 4)
  int r3 = f(s1, s4);  // f can hve side effects
      r3 = f(s1, s4);
      r3 = f(s1, s4);
      r3 = f(s1, s4);
      r3 = f(s1, s4);
  printf("%d, %d, %d\n", r1, r2, r3);
  free(s4);
  return 0;
}
